#!/usr/bin/perl

use v5.34;

use feature 'try';
no warnings 'experimental::try';

try {
    die ErrorObject->new( 'An error occured' );
}
catch ( $error ) {
    warn sprintf "The code inside 'try' died with error: '%s'",
        $error->message;
}

{
    package ErrorObject;

    sub new {
        my ($class,$msg) = @_;
        return bless {message => $msg}, $class;
    }

    sub message {
        my ($self) = @_;
        return $self->{message};
    }
}
