use v5.37.8;

use experimental 'class';

use JSON;
use Mojo::UserAgent;

class GPW 0.01 {
    field $year :param;
	field $talks;
	
	ADJUST {
		my $ua       = Mojo::UserAgent->new;
		my $base_url = 'https://act.yapc.eu/gpw' . $year;
		
		my $tx = $ua->get( $base_url . '/talks' );
		$talks = $tx->res->dom
            ->find('a[href^="/gpw' . $year . '/talk/"]>b');
            ->map( sub {
                $_->text;
            });
	}
	
	method info ( $format = 'data' ) {
	    my %info = (
		    year      => $year,
			talks     => $talks->to_array,
		);
		
		return JSON->new->utf8(1)->encode( \%info ) if $format eq 'json';
		return \%info;
	}
}
