#!/usr/bin/perl

use v5.24;

use Test::More;
use Test::Mojo;
use Mojo::File qw(curfile);

my $t = Test::Mojo->new(curfile->sibling('miniapp.pl'));
warn $t->ua->server->url;
$t->get_ok('/')
  ->status_is(200)
  ->text_is('h1' => 'Test');

$t->tx->res->body( '<html><body><h2>Hallo</h2></body></html>');
$t->text_is( 'h2' => 'Hallo' );

done_testing;
