# About me
  
* Renée Bäcker
  * Owner of <a href="https://perl-services.de">Perl-Services.de</a> (<a href="https://metacpan.org/author/PERLSRVDE">PERLSRVDE @ cpan</a>)
  * <a href="https://perl-academy.de">Perl-Academy.de</a>
  * <a href="https://metacpan.org/author/RENEEB">RENEEB @ cpan</a>
  * Interests: Perl, IT-Security

------

# Links

  * This talks is already available at [https://talks.perl-academy.de](https://talks.perl-academy.de)
  * Code is available at [https://os.perl-services.de/perl-academy](https://os.perl-services.de/perl-academy)

------

# Tests, Tests, Tests

We all love to write tests, right?

  * Unit tests
  * Integration tests
  * ...

---

# A mini app

```perl[1-4|8-13|]
use Mojolicious::Lite;

get '/' => 'index';
app->start;

__DATA__
@@ index.html.ep
<html>
  <head>
  <style>h1 { }</style>
  </head>
  <body><h1>Test</h1></body>
</html>
```

---

# A mini app

<img src="img/app_1.png">

---

# Everything works, doesn't it?

```perl[1,5-9|]
use Test::Mojo;
use Mojo::File qw(curfile);

my $app = curfile->sibling('miniapp.pl');
my $t = Test::Mojo->new($app);
$t->get_ok('/')
  ->status_is(200)
  ->text_is('h1' => 'Test');

done_testing();
```

---

# Everything works, doesn't it?

```text
# perl test1.pl 
ok 1 - GET /
ok 2 - 200 OK
ok 3 - exact match for selector "h1"
1..3
```


---

# A minor change...

---

# ... and it still works, kind of

------

# What is Playwright?

  * Tool for automating web browser interactions
  * Written with nodejs
  * Developed by Microsoft
  * Works with multiple browsers
  * Allows for writing automated tests and other types of web automation

---

# Perl and Playwright

There's a module to use Playwright in Perl: _Playwright_

  * It needs a running installation of the Playwright tool

```perl
use Playwright;

my $pw = Playwright->new();
my $browser = $pw->chromium->launch(headless => 1);
my $page = $browser->newPage();
$page->goto('https://perl-academy.de');
$browser->close();
```

---

# Navigating the Web with Perl and Playwright

  * `$page->goto('https://www.example.com')`
  * `$page->click('#submit-button')`
  * `$page->type('#name-input', 'John Doe')`

---

# Extracting Data from Web Pages

  * `$page->textContent('.my-class')`
  * `$page->getAttribute('#my-element', 'href')`
  * `$page->evaluate('document.title')`

---

# Automating Forms with Perl and Playwright

  * `$page->type('#name', 'John Doe')`
  * `$page->type('#email', 'johndoe@example.com')`
  * `$page->selectOption('#country', 'Canada')`
  * `$page->check('#newsletter')`
  * `$page->click('#submit')`

---

# JavaScript fun ...

---

# a pain for testers?

------


